/*------------------------------------------------------------------------------
-- This file is a part of the QLop Software
-- Copyright (C) 2015, Plasma Physics Laboratory - CNRS
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
-------------------------------------------------------------------------------*/
/*-- Author : Alexis Jeandet
-- Mail : alexis.jeandet@member.fsf.org
----------------------------------------------------------------------------*/
#ifndef QLOPDATABASE_H
#define QLOPDATABASE_H

#include <QObject>
#include <qlopdata.h>
#include <QList>
#include <qlopservice.h>

class QLopDataBaseViewer;

class QLopDataBase : public QLopService
{
    Q_OBJECT
    static QDockWidget* m_gui;
    QLopDataBase(bool noGUI=false,QObject *parent = 0);
    ~QLopDataBase();
    static QLopDataBase* _self;
public:
    QDockWidget* getGUI();
    static void init(bool noGUI=false,QObject *parent = 0);
    const QString& serviceName();
    static int addData(QLopData* data);
    static int addData(const QLopDataList &data);
    static int removeData(QLopData* data);
    static int removeData(const QLopDataList &data);
    static QLopDataBase* self();
    static int count();
    static QLopData* getData(const QString& name);
    static QLopData* getData(int ID);
    QLopData* getDataFromIdex(int index);
signals:
    void DBChanged();
public slots:
private:
    static QList<QLopData*>* m_dataBase;
};

#endif // QLOPDATABASE_H
